import numpy as np
import lqmtest_x3_5_pool
import lqmtest_x3_2_load_data
import lqmtest_x3_4_conv_proc
import lqmtest_x3_6_fullconn


class ModelObj: # 网络对象
    def __init__(self, ObjID, ObjType, ObjLable, ParaString, ObjX, ObjY):
        self.ObjID = ObjID  # 图元号
        self.ObjType = ObjType  # 图元类别
        self.ObjLable = ObjLable  # 对象标签
        self.ParaString = ParaString  # 参数字符串
        self.ObjX = ObjX  # 对象位置x坐标
        self.ObjY = ObjY  # 对象位置y坐标
class Nonline_Class(ModelObj):  # 非线性对象
    def __init__(self, ObjID, ObjType, ObjLable, ParaString, ObjX, ObjY):
        super().__init__(ObjID, ObjType, ObjLable, ParaString, ObjX, ObjY)
        self.NonlinearProc = self.nonlinear_proc  # 基本操作函数
        self.SetNonLPara = self.setnonl_para  # 参数设置函数
    def nonlinear_proc(self, inputdata, NonLPara): # 定义非线性函数
        # 从NonLPara参数中获取非线性函数类型
        nonlinearmode = NonLPara["nonlinearmode"]
        if nonlinearmode == "Sigmoid":
            # Sigmoid函数，将任何实数的输入映射到0和1之间的输出
            output = 1 / (1 + np.exp(-inputdata))
        elif nonlinearmode == "ReLU":
            # ReLU函数，将负数输入置为0，而正数输入保持不变
            output = np.maximum(inputdata, 0)
        elif nonlinearmode == "Tanh":
            # Tanh函数，将任何实数的输入映射到-1和1之间的输出
            output = np.tanh(inputdata)
        else:
            # 非法的非线性类型，抛出异常
            raise ValueError("Invalid nonlinear mode")
        return output  # 返回计算后的值
    def setnonl_para(self):  # 定义设置非线性参数的函数
        # 确定参数信息：非线性函数的类型。可以选择"Sigmoid", "ReLU" 或 "Tanh"
        nonlinearmode = input("请输入非线性函数的类型（Sigmoid/ReLU/Tanh）：")
        # 返回NonLPara参数，这里用一个字典来存储
        NonLPara = {"nonlinearmode": nonlinearmode}
        return NonLPara  # 返回NonLPara参数
if __name__ == '__main__':
    DataSet = lqmtest_x3_2_load_data.Data_Class("DataSet1", 1, "数据集1", [], 120, 330)
    # setload_data()函数，获取加载数据集的参数
    DataPara = DataSet.SetDataPara()
    train_images, test_images = DataSet.LoadData(DataPara)

    Conv = lqmtest_x3_4_conv_proc.Conv_Class("Conv1", 2, "卷积1", [], 250, 330)
    ConvPara = Conv.SetConvPara()
    for i in range(len(train_images) // 32):
        images = train_images[i * 32:(i + 1) * 32]
        conv_images = []  # 存储卷积处理后的图片的列表
        for image in images:  # 获取训练集的图片数据
            dim = len(image.shape)  # 获取矩阵的维度
            if dim == 2:  # 如果是二维矩阵,则转化为三维矩阵
                image_h, image_w = image.shape
                image = np.reshape(image, (1, image_h, image_w))
                # 调用ConvProc()函数，根据ConvPara参数完成卷积计算
                output = Conv.ConvProc(image, ConvPara)
                conv_images.append(output)  # 将卷积结果存储到列表
            elif dim == 3:  # 若为三维矩阵，则保持不变直接卷积处理
                output = Conv.ConvProc(image, ConvPara)
                conv_images.append(output)
        # 将卷积处理后的图片列表转换为数组形式，方便后续处理
        conv_images = np.array(conv_images)
    
    Pool = lqmtest_x3_5_pool.Pool_Class("Pool1", 3, "最大池化1", [], 380, 330)
    PoolPara = Pool.SetPollPara()
    pool_images = []  # 存储池化处理后的图片的列表
    for image in conv_images:  # 获取卷积后的图片数据
        output = Pool.MaxPoolProc(image, PoolPara)
        pool_images.append(output)  # 将池化结果存储到列表
    # 将池化处理后的图片列表转换为数组形式，方便后续处理
    pool_images = np.array(pool_images)
    
    _, _, poolH, poolW = pool_images.shape
    FullConn = lqmtest_x3_6_fullconn.FullConn_Class("FullConn1", 4, "全连接1", [], 510, 330)
    FullConnPara = FullConn.SetFullConnPara(poolH, poolW)
    
    fullconn_images = []      # 存储全连接处理后的图片的列表
    for image in pool_images: # 获取池化后的图片数据
        output = FullConn.FullConnProc(image, FullConnPara)
        fullconn_images.append(output)  # 将全连接处理后的结果存储到列表
    # 将全连接处理后的图片列表转换为数组形式，方便后续处理
    fullconn_images = np.array(fullconn_images)
    
    Nonline = Nonline_Class("Nonline1", 5, "非线性函数1", [], 640, 330)
    NonLPara = Nonline.SetNonLPara()
    # 存储非线性处理后的图片的列表
    nonlinear_images = []
    for image in fullconn_images:  # 获取全连接处理后的图片数据
        output = Nonline.NonlinearProc(image, NonLPara)
        # 将非线性处理后的结果存储到列表
        nonlinear_images.append(output)
    # 将非线性处理后的图片列表转换为数组形式，方便后续处理
    nonlinear_images = np.array(nonlinear_images)
